#!/usr/local/bin/python

import socket
import select

__all__ = [ 'divert' ]

IPPROTO_DIVERT = 258

class Divert:
	def __init__(self, port, block = True, bufsize = 2048):
		self.sock = socket.socket(socket.AF_INET, socket.SOCK_RAW,
		    IPPROTO_DIVERT)
		self.sock.bind(('127.0.0.1', port))
		self.block = block
		self.bufsize = bufsize
		self.sock.setblocking(block)

	def handlepkt(self, buf, addr):
		raise NotImplementedError

	def sendpkt(self, buf, addr = None):
		if addr != None:
			return self.sock.sendto(buf, addr)
		else:
			return self.sock.send(buf)

	def checkandhandle(self, timeout = None):
		args = [ [self.sock], [], [] ]
		if timeout != None:
			args.append(timeout)
		rd, foo, foo = apply(select.select, args)
		if rd:
			buf, addr = self.sock.recvfrom(self.bufsize)
			if buf:
				self.handlepkt(buf, addr)
